***** Main Program
***** Set defaults
SET CURSOR OFF
SET ESCAPE ON
SET COLOR TO "W/B,W+/R"
***** Declare and fill array for achoice
DECLARE array[5]
array[1]="1-Array choice"
array[2]="2-Array choice"
array[3]="3-Array choice"
array[4]="4-Array choice"
array[5]="5-Array choice"
***** Declare needed public variables
* achoice mode values
idle=0
top=1
bot=2
excep=3
noitem=4
* achoice udf return values
abort=0
select=1
continue=2
keymatch=3

fixcorn=.F.                             && trigger that HELP sets
                                        && to .T. if called by achoice
corner = ""                             && public var for later screen saving
***** Menu Loop
DO WHILE .T.
     CLEAR
     @ 0,0 TO 24,79 DOUBLE
     choice=achoice(7,33,11,47,array,"","achoice_udf")
     IF choice=0                        && Quit if esc pressed
          QUIT
     ELSE
          CLEAR
          @ 5,5 SAY "Branching for selection "+str(choice,1)
          @ 7,5 SAY "Press any key to return..."
          inkey(0)
     ENDIF
ENDDO

******************************************************************************
***** Achoice UDF

FUNCTION achoice_udf
PRIVATE mode,element,rel_pos,esc,enter,key
PARAMETERS mode, element, rel_pos
esc=27
enter=13
key=lastkey()

IF mode=idle.or.mode=top.or.mode=bot    && idle,past top or past bottom
     ret_val=continue
ELSEIF mode=excep                       && A keystroke exception entered

     IF fixcorn
                                        ** This is called only if achoice
                                        ** just called a screen writing
                                        ** routine. ie. HELP
          restscreen(23,78,24,79,corner)&& fix the lower right corner 24,79 that
                                        ** achoice just messed up
          fixcorn=.F.                   && no need to call this again until
     ENDIF

     IF key=esc
          ret_val=abort                 && return 0 to abort
     ELSEIF key=enter
          ret_val=select                && return 1 to select it
     ELSE                               && if possible go to choice starting
          ret_val=keymatch              && with the keystroke entered
     ENDIF

ELSEIF mode=noitem                      && No items selectable
     ret_val=abort                      && return 0 to abort
ENDIF
return(ret_val)
******************************************************************************
***** Help Procedure
PROCEDURE HELP
PRIVATE proc,line,in_var
PARAMETERS proc,line,in_var

IF proc="HELP"                          && Don't let HELP call itself
     RETURN
ENDIF

oldcolor=setcolor("W+/R")               && save old color and set new
SAVE SCREEN TO oldscr                   && save original screen

IF proc="ACHOICE"                       && if HELP was called by achoice
     corner=savescreen(23,78,24,79)     && save the portion of screen that
                                        ** achoice will mess up
     fixcorn=.T.                        && fix the corner later, only to be set .T.
                                        ** if achoice called this proc.
ENDIF


CLEAR SCREEN                            && do HELP routine here
@ 5,5 SAY "HELP..."
inkey(0)                                && HELP routine ends


IF proc="ACHOICE"                       && if HELP was called by achoice
     @24,79                             && achoice likes to mess up the area
                                        ** where the cursor last was (0,0 if the
                                        ** cursor was off).  If we put the cursor
                                        ** at 24,79 only 1 position will be messed
                                        ** up, and since its only one block in the
                                        ** lower right corner it probably won't
                                        ** be noticed for the few milliseconds it
                                        ** shows, even at 4.77 mhz

     KEYBOARD ""                       && the "" will be treated as a menu choice
                                        ** upon the first call to the achoice UDF.
                                        ** this will cause the udf to repaint the
                                        ** tarnished area in the achoice menu
ENDIF

RESTORE SCREEN FROM oldscr              && restore the old screen
setcolor(oldcolor)                      && reset color to the old color

RETURN